if (Object.create !== 'function') {
    Object.create = function (Object) {
        function F() { };
        F.prototype = Object;
        return new F();
    }
}

(function ($, window, document, undifined) {

    var CHECKBOX = {
        init: function (setting, element){
            var self = this;
            this.options = $.extend({},$.fn.RezvaniCheckbox.options , setting);
            // this.$elem starnd for input
            this.$elem = $(element);
            this.attrs = {};
            $.each(element.attributes,function (){
                if (this.specified) {
                    self.attrs[this.name] = this.value;
                }
            });
            this.buildFrag(this.attrs);
            // this.$subElem stand for user element
            this.$subElem = this.$elem.next(this.options.tag);
            this.$subElem.on('click', function () {
                var $this = $(this);
                if ( !this.attributes.checked ) {
                    $this.addClass('fas fa-check');
                    this.attributes.checked = true;
                    if (typeof self.options.onCheck === 'function') {
                        self.options.onCheck.apply(self.elem, arguments);
                    }
                } else {
                    this.attributes.checked = false;
                    $this.removeClass('fas fa-check');
                    if (typeof self.options.onUncheck === 'function') {
                        self.options.onUncheck.apply(self.elem, arguments);
                    }
                }
            });
        },
        buildFrag: function (ATTRS){
            var tag = this.options.tag;
            $('<'+tag+'></'+tag+'>').attr(ATTRS).insertAfter(this.$elem);
            this.$elem.hide();
        },
        status:function (){
            var $this = $(this);
            if (!$this.hasClass('check')) {
                $this.addClass('check');
            } else {
                $this.addClass('check');
            }
        }
    };

    $.fn.RezvaniCheckbox = function (options){
        return this.each(function (){
            var fetch = Object.create(CHECKBOX);
            // this is element that we Grap with jQuery
            fetch.init(options,this);
            // console.log(fetch);
        });
    };

    $.fn.RezvaniCheckbox.options = {
        tag:'i',
        onCheck: null,
        onUncheck: null
    };

})(jQuery, window, document);
